/* $Id: wprojeziere.c,v 1.20 1999/01/31 19:35:37 fzk Exp $ */

/* Projektion der Raumpunkte auf die Zeichenebene */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <math.h>
#include "wuerfel.h"

/* Aufriss (ohne Bercksichtigung der Koordinate v) */
#define AUF(a,b) s[i].x1 = (short)(dx + fx *  KS(a,u)); \
                 s[i].y1 = (short)(dy + fy * -KS(a,w)); \
                 s[i].x2 = (short)(dx + fx *  KS(b,u)); \
                 s[i].y2 = (short)(dy + fy * -KS(b,w)); \
                 i++;

/* Beispiel fr eine Grundrissprojektion */
#define GR(a,b) s[i].x1 = dx + fx *  KS(a,u); \
                s[i].y1 = dy + fy * -KS(a,v); \
	        s[i].x2 = dx + fx *  KS(b,u); \
                s[i].y2 = dy + fy * -KS(b,v); \
		i++;

/* Isometrie */
/* #define AUF(a,b) s[i].x1 = dx + fx *  (-0.35355*KS(a,v)+KS(a,u)); \ */
/*                  s[i].y1 = dy + fy * -(-0.35355*KS(a,v)+KS(a,w)); \ */
/*                  s[i].x2 = dx + fx *  (-0.35355*KS(b,v)+KS(b,u)); \ */
/*                  s[i].y2 = dy + fy * -(-0.35355*KS(b,v)+KS(b,w)); \ */
/*                  i++; */

/* Die Position des Wrfelgrtels WGPOS *wpg wird erst um die 3 Winkel
   wu, wv und ww gedreht und dann mittels macro AUF() auf die
   Darstellungsebene (u/w-Ebene) projeziert.
   Returnwert ist die Anzahl der berechneten X-Segments
*/
int
projeziere (OPTIONS o,
	    WGPOS *wgp,
	    BWINKEL wu, BWINKEL wv, BWINKEL ww,
	    XSegment *s)
{
    WGPOS twgp;
    double fx, fy, dx, dy;
    int i = 0;
    int j;
    int k;

    dx = o.seite / 5.;
    dy = o.seite / 2.;
    fx = fy = o.seite / 3.;

    /*
    ** Zuerst Drehung um die x-Achse um den Winkel wu berechnen */
    for (j=1; j<=ANZPUNKTE; j++) {
	KS(j,u) = KP(j,u);
	KS(j,v) = KP(j,v)*  cos(wu) + KP(j,w)*sin(wu);
	KS(j,w) = KP(j,v)* -sin(wu) + KP(j,w)*cos(wu);
    }

    /*
    ** Dann Drehung um die y-Achse um den Winkel wv
    */
    for (j=1; j<=ANZPUNKTE; j++) {
	RPUNKT zwi;

	zwi.u = KS(j,u);
	zwi.v = KS(j,v);
	zwi.w = KS(j,w);
	KS(j,u) = zwi.u*  cos(wv) + zwi.w* sin(wv);
	KS(j,v) = zwi.v;
	KS(j,w) = zwi.u* -sin(wv) + zwi.w* cos(wv);
    }

    /*
    ** Schliesslich Drehung um die z-Achse um den Winkel ww
    */
    for (j=1; j<=ANZPUNKTE; j++) {
	RPUNKT zwi;

	zwi.u = KS(j,u);
	zwi.v = KS(j,v);
	zwi.w = KS(j,w);
	KS(j,u) = zwi.u*  cos(ww) + zwi.v* sin(ww);
	KS(j,v) = zwi.u* -sin(ww) + zwi.v* cos(ww);
	KS(j,w) = zwi.w;
    }

/*   GR(1,2) */
/*   GR(1,3) */
/*   GR(1,9) */
/*   GR(1,10) */
/*   GR(5,6) */
/*   GR(5,7) */
/*   GR(5,9) */
/*   GR(5,10) */
    /* Teil 1 */
    for (k=0; k<6; k++) {
	AUF (kante[k].von, kante[k].nach)
    }
/*   AUF(1,2) */
/*   AUF(1,3) */
/*   AUF(1,4) */
/*   AUF(2,3) */
/*   AUF(4,3) */
/*   AUF(4,2) */
  /* Teil 2 */
  AUF(3,7)
  AUF(3,8)
  AUF(4,7)
  AUF(4,8)
  /* Teil 3 */
  AUF(5,6)
  AUF(5,7)
  AUF(5,8)
  AUF(7,8)
  AUF(7,6)
  AUF(8,6)
  /* Untere Haelfte */
  /* Die Nummern der gespiegelten Punkte ergeben sich durch Addition von 10 */
  /* Spiegelung von Teil 1 */
  /* AUF(11,12)  */ /* ist ident mit AUF(1,2) */
  AUF(12,13)
  AUF(13,11)
  AUF(11,14)
  AUF(14,13)
  AUF(14,12)
  /* Spiegelung von Teil 2 */
  AUF(13,17)
  AUF(13,18)
  AUF(14,17)
  AUF(14,18)
  /* Spiegelung von Teil 3 */
  /* AUF(15,16) */ /* ist ident mit AUF(5,6) */
  AUF(15,17)
  AUF(15,18)
  AUF(17,18)
  AUF(17,16)
  AUF(18,16)

      /*
      ** die Achsen
      */
      anzduenn = 0;
      if (o.ach) {
	  AUF(1,19)
	  AUF(1,20)
	  AUF(1,21)
	  anzduenn += 3;
      }

     /*
     ** Die Kanten zum Evolutionspunkt und zum Involutionspunkt
     */
     if (o.ei) {
	 AUF(4,9)
	 AUF(6,9)
	 AUF(14,9)
	 
	 AUF(2,10)
	 AUF(8,10)
	 AUF(18,10)
	 anzduenn += 6;
     }
     return i;
}
