/* $Id: wuerfel.h,v 1.20 1999/01/31 19:35:37 fzk Exp $ */

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#define DELTA 0.001

#define FILE2D(i1, i2) "daten2d"#i1#i2".txt"
#define FILE3D         "daten3d.txt"
#define FILESEGS       "datensegs.txt"

#define ANZPUNKTE 21

typedef double CKOORD;            /* eine kartesische Koordinate */
typedef double BWINKEL;           /* ein Winkel im Bogenmass */
#define GWINKEL(b) (double)((b)*180./M_PI)    /* Bogenmass in Grad umrechnen */

#define P(n,i) (wgp->e[n-1].i)    /* Punkt als Pointer */
#define S(n,i) (twgp.e[n-1].i)    /* Punkt als Struktur */

#define KP(n,i) (P(n,i))          /* Koordinate i der Ecke n (Punkt n) */ 
#define KS(n,i) (S(n,i))          /* Koordinate i der Ecke n (Punkt n) */

typedef struct segs {
    char von;
    char nach;
} KANTE;

typedef enum boolean {
    FALSE = 0,
    TRUE = 1,
    nein = FALSE,
    ja = TRUE
} BOOLEAN;

typedef struct epunkt {      /* ein Punkt in der Ebene */
    CKOORD x;
    CKOORD y;
} EPUNKT;

typedef struct rpunkt {      /* ein Punkt im Raum */
    CKOORD u;
    CKOORD v;
    CKOORD w;
} RPUNKT;

typedef struct wgpos {       /* die Ecken an der Position w */
    BWINKEL w;
    RPUNKT e[ANZPUNKTE];
} WGPOS;

typedef struct wgplist {     /* der Wuerfelguertel als Liste der Positionen */
    WGPOS wgp;
    struct wgplist *nextwgp;
} WG;

typedef struct options {     /* Aufrufparameter */
    unsigned int seite;      /* -b Breite des Fensters in Pixeln */
    BWINKEL      dw;         /* -w Winkel, um den sich 2 Pos. unterscheiden */
    BOOLEAN      print;      /* -p print, gibt Koordinaten der Eckpunkte aus */
    BOOLEAN      ei;         /* -e Evolutions- und Involutionspunkt zeichnen */
    BOOLEAN      ach;        /* -a Evolutions- und Involutionspunkt zeichnen */
} OPTIONS;

WG   *berechnewg   (OPTIONS o, int *anzelt);
void berechnewgpos (BWINKEL winkel, WGPOS *wgp);
void zeichnewg     (OPTIONS *o, WG *wg);
void printwg       (OPTIONS o, WG *wg);
int  projeziere    (OPTIONS o, WGPOS *wgp, BWINKEL wx, BWINKEL wy, BWINKEL wz,
		    XSegment *p);
void freewg        (WG *wg);
void getoptions    (int argc, char **argv, OPTIONS *o);
void ident         (void);
void usage         (void);
void control       (void);
void warten        (int sec);

#ifdef DEFINECONSTANTS
/* Die Kanten des Wrfelgrtels liegen jeweils zwischenden zwei Ecken */
KANTE kante[] = {
    /* Teil 1 */ { 1, 2}, { 1, 3}, { 1, 4}, { 2, 3}, { 2, 4}, { 3, 4},
    /* Teil 2 */ { 3, 7}, { 3, 8}, { 4, 7}, { 4, 8},
    /* Teil 3 */ { 5, 6}, { 5, 7}, { 5, 8}, { 6, 7}, { 6, 8}, { 7, 8},
    /* Teil 1'*/ /* {11,12},*/ {11,13}, {11,14}, {12,13}, {12,14}, {13,14},
    /* Teil 2'*/ {13,17}, {13,18}, {14,17}, {14,18},
    /* Teil 3'*/ /* {15,16},*/ {15,17}, {15,18}, {16,17}, {16,18}, {17,18}
};
int anzkanten = sizeof (kante) / sizeof (kante[0]);
int anzduenn; /* Anzahl der dnn zu zeichnenden Segmente */
BOOLEAN rechnung_nicht_ok = FALSE;
#else
extern KANTE kante[];
extern int anzkanten;
extern int anzduenn;
extern BOOLEAN rechnung_nicht_ok;
#endif
