/* $Id: wzeichne.c,v 1.20 1999/01/31 19:35:37 fzk Exp $ */

/* Zeichnen des Wuerfelguertels mit X-Windows */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include "wuerfel.h"

#define ADDX(f) {if ((f)>0) {wu += M_PI/180.; if (wu > 2.*M_PI) {wu = DELTA;}}\
                 else {wu -= M_PI/180.; if (wu < -2.*M_PI) {wu = DELTA;}}}
#define ADDY(f) {if ((f)>0) {wv += M_PI/180.; if (wv > 2.*M_PI) {wv = DELTA;}}\
                 else {wv -= M_PI/180.; if (wv < -2.*M_PI) {wv = DELTA;}}}

#define DRAWSEGS \
        XDrawSegments (display, window, gcxor2, s, count-anzduenn); \
	XDrawSegments (display, window, gcxor1, s+count-anzduenn, anzduenn);

#define REDRAW \
	DRAWSEGS \
	count = projeziere (*o, &(wgp->wgp), wu, wv, ww, s); \
	DRAWSEGS
void
zeichnewg (OPTIONS  *o, WG *wg) {
    Display *display;
    int     screen;
    Window  window;
    XEvent  event;
    unsigned long mask;

    unsigned int width;
    unsigned int height;
    unsigned int border_width;
    int          x, y;

    GC        gcxor1;
    GC        gcxor2;
    XGCValues gcvalues;

    int    firsttime = TRUE;
    BWINKEL wu, wv, ww;
    int mx, my;
    XSegment s[36]; /* Wieviele Segmente hat der Wuerfelguertel eigentlich ? */

    WG *wgp;
    BOOLEAN  halt = FALSE;

    struct timeval waittime;
    long wait_usec;
    long l, z;
    int count = 0;

    l = z = 0;
    wu = wv = ww = DELTA;
    mx = my = 0;

    border_width = 10;
    x = y = 0;

    if ((display = XOpenDisplay (getenv("DISPLAY"))) == NULL) {
	fprintf (stderr, "Cannot open Display\n");
	exit (1);
    }

    screen = DefaultScreen (display);

    if ((*o).seite == 0) {
	width = DisplayWidth (display, screen) / 2;
	/* height = DisplayHeight (display, screen) / 2; */
	height = width;
	(*o).seite = width;
    }
    else {
	width = height = (*o).seite;
    }

    window = XCreateSimpleWindow (display, RootWindow (display, screen),
				  x, y, width, height, border_width,
				  BlackPixel (display, screen),
				  WhitePixel (display, screen));

    mask = GCForeground | GCFunction | GCLineWidth;
    gcvalues.function = GXxor;
    gcvalues.foreground = BlackPixel (display, screen) ^
	                              WhitePixel (display, screen);
    gcvalues.line_width = 2;

    gcxor2 = XCreateGC (display, window, mask, &gcvalues);
    gcvalues.line_width = 1;
    gcxor1 = XCreateGC (display, window, mask, &gcvalues);

    XSetStandardProperties (display, window, "Der Umstlpbare Wrfel",
			    "Schatz", 0, NULL, 0, NULL);

    mask = ExposureMask |
	   KeyPressMask;

    XSelectInput (display, window, mask);

    XMapWindow (display, window);

    wgp=wg;

    waittime.tv_sec = 0;
    waittime.tv_usec = 100000;

    while (TRUE) {
	/* XNextEvent (display, &event); */
	/* XWindowEvent (display, window, mask, &event); */
	if (XCheckWindowEvent (display, window, mask, &event)) {
	    /* fprintf (stderr, "event.type=%d\n",  event.type); */

	    switch (event.type) {
		char *ksstring;

	    case Expose:
/* 		fprintf (stderr, "Expose "); */
/* 		while  (XCheckTypedEvent(display, Expose, &event)) { */
/* 		    fprintf  (stderr, "."); */
/* 		} */
/* 		fprintf (stderr, "\n"); */
		XClearWindow (display, window);
		DRAWSEGS
		break;

	    case KeyPress:
		ksstring = XKeysymToString (XKeycodeToKeysym (display, event.xkey.keycode, 0));
		/* fprintf (stderr, "keypressed keycode=%d keysym=<%s>",
                            event.xkey.keycode, ksstring); */
	      
		if (! strcmp ("plus", ksstring)) {
/* 		    fprintf (stderr, " + "); */
		    if (waittime.tv_usec == 0) {
			waittime.tv_usec = 1;
		    }
		    else {
			waittime.tv_usec = waittime.tv_usec * 2;
		    }
		    if (waittime.tv_usec > 10000000) {
			waittime.tv_usec = 10000000;
		    }
		}
		else if (! strcmp ("minus", ksstring)) {
/* 		    fprintf (stderr, " - "); */
		    waittime.tv_usec = waittime.tv_usec / 2;
		}
		else if (! strcmp ("q", ksstring)) {
/* 		    fprintf (stderr, " q\n"); */
		    XCloseDisplay (display);
		    exit (0);
		}
		else if (! strcmp ("s", ksstring)) {
/* 		    fprintf (stderr, " s "); */
		    halt = ! halt;
		}
		else if (! strcmp ("u", ksstring)) {
/* 		    fprintf (stderr, " u "); */
		    wu = wu > 2.*M_PI ? DELTA : wu + M_PI/30.;
		    REDRAW
		}
		else if (! strcmp ("v", ksstring)) {
/* 		    fprintf (stderr, " v "); */
		    wv = wv > 2.*M_PI ? DELTA : wv + M_PI/30.;
		    REDRAW
	        }
		else if (! strcmp ("w", ksstring)) {
/* 		    fprintf (stderr, " w "); */
		    ww = ww > 2.*M_PI ? DELTA : ww + M_PI/30.;
		    REDRAW
		}
		else if (! strcmp ("e", ksstring)) {
/* 		    fprintf (stderr, " e "); */
		    (*o).ei = ! (*o).ei;
		    REDRAW
	        }
		else if (! strcmp ("a", ksstring)) {
/* 		    fprintf (stderr, " a "); */
		    (*o).ach = ! (*o).ach;
		    REDRAW
		}
		else if (! strcmp ("0", ksstring)) {
/* 		    fprintf (stderr, " 0 "); */
		    wu = wv = ww = DELTA;
		    REDRAW
	        }
/* 		fprintf (stderr, " wait=%d wu=%5.3f wv=%5.3f ww=%5.3f\n", */
/* 			 (int)waittime.tv_usec, wu, wv, ww); */
		break;
	    }
	}

	if (! halt) {
	    if (! firsttime) {
		/* aktuelle Zeichnung lschen */
		DRAWSEGS
		firsttime = FALSE;
	    }

	    count = projeziere (*o, &(wgp->wgp), wu, wv, ww, s);
	    wgp = wgp->nextwgp ? wgp->nextwgp : wg;

	    DRAWSEGS

	    wait_usec = waittime.tv_usec;
	    select (0, NULL, NULL, NULL, &waittime); 
	    waittime.tv_usec = wait_usec;

	    if (firsttime) {
		/* sleep (3); */
		firsttime = FALSE;
	    }
	}
    }
}

